  public class DFS_matice{
  Vrchol [] vrcholy;            // deklarace promennych tridy BFS_matice
  int [] [] matice;
  int pocet;
    
    
    
//********************************************************************** 
  
  private  class Vrchol {

    char barva;
    int vzdalenost;
    int predchudce;
    int objeven;
    int dokoncen;
  
    Vrchol () {
      vzdalenost = -1;
      barva= 'B';
      predchudce = -1;
      objeven = 0;
      dokoncen = 0;
    }
  }
  
  
    //**********************************************************************
     private class IntFronta {       // Trida intFronta slouzi k ukladani indexu sousedu pri pruchodu grafem
  
    private class Clen {
      int klic;
      Clen dalsi;
    
      Clen(int klic) {
        this.klic = klic;
        this.dalsi = null;
      }
    }
  
    private Clen zacatek, konec;
  
    IntFronta() {
      zacatek = null;
      konec = null;
    }
  
    boolean jePrazdna() {
      return (zacatek == null);
    }
  
    void vloz(int klic) {
      Clen k = konec;
      konec = new Clen(klic);
      if (jePrazdna()) {
        zacatek = konec;
      }
      else {
        k.dalsi = konec;
      }
    }
  
    int vyber() {
      int v = zacatek.klic;
      zacatek = zacatek.dalsi;
      return v;
    }
  }
     
   /******************************************************/  

   
   void zadaniGrafu() {               // metoda pro zadani matice sousednosti a pole vrcholu
   System.out.println("Zadejte pocet vrcholu grafu :");
    this.pocet = ctiInt()+1;
    vrcholy = new Vrchol [pocet];
    matice = new int [pocet] [pocet]; 
     for (int j = 1; j < pocet; j++) {    
        vrcholy[j] = new Vrchol();
        System.out.println("Zadejte pocet sousedicich vrcholu vrcholu " +j+ " : ");
        int k = ctiInt();
        for (int i = 1; i <= k; i++) {
          System.out.println("Zadejte "+i+". sousedici vrchol :");
          int s = ctiInt();
          matice [j] [s] = 1;
        }
      }
    }
   
   void tiskGrafu () {
   //  for (int i = 0; i<pocet ; i++);
     for (int i = 1; i< pocet; i++) {
       System.out.print (i + " |");
       for (int j = 1; j < pocet; j++) {
         System.out.print ( "  " + matice [i] [j] );
       }
       System.out.println();
     }
   }
 //--------------------------------------------------------------------------  
    
     void dfs (int s) {                   // metoda pro pruchod DFS
      int cas = 0;
      System.out.println("Pruchod DFS:");
      dfsPom(s,cas);
      for (int i = 1; i < pocet; i++) {
        if (vrcholy[i].objeven == 0) {
          dfsPom (i,cas);
        }
      }
    }
   
   void dfsPom (int s,int cas) {        // pomocna metoda pro pruchod DFS
      vrcholy[s].barva = 'S';
      cas = cas + 1;
      vrcholy[s].objeven = cas;
      for ( int i = 1; i < pocet; i++ ) {
       if ( matice [s] [i] == 1) {
        if ( vrcholy[i].barva == 'B' ) {
          vrcholy[i].predchudce = s;
          dfsPom(i,cas);
        }
       }
      }
     vrcholy[s].barva = 'C';
      System.out.print(s+" ");
      vrcholy[s].dokoncen = cas = cas + 1;
    }
   //---------------------------------------------------------------------  
    private int ctiInt() {             // metoda pro vstup dat z klavesnice
      byte[] pole = new byte[200];
      try { 
         System.in.read(pole);
         return Integer.parseInt(new String(pole).trim());
      } 
      catch (Exception e) {
        System.out.println("Chybne nactene cislo !");
      return 0;
      }
   }
}
   